#!/bin/sh

# Copyright (C) 2007 Google Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.

set -e

DEFAULT_FILE="/etc/default/ganeti-instance-debootstrap"
if [ -f "$DEFAULT_FILE" ]; then
    . "$DEFAULT_FILE"
fi

# note: we don't set a default mirror since debian and ubuntu have
# different defaults, and it's better to use the default

# only if the user want to specify a mirror in the defaults file we
# will use it, this declaration is to make sure the variable is set
: ${MIRROR:=""}
: ${PROXY:=""}
: ${SUITE:="lenny"}
: ${ARCH:=""}
: ${EXTRA_PKGS:=""}
: ${GENERATE_CACHE:="yes"}
: ${CLEAN_CACHE:="14"} # number of days to keep a cache file

CACHE_DIR="/var/cache/ganeti-instance-debootstrap"

if [ "$GENERATE_CACHE" = "yes" -a ! -d "$CACHE_DIR" ]; then
  mkdir -p "$CACHE_DIR"
fi

DPKG_ARCH=${ARCH:-`dpkg --print-architecture`}
CACHE_FILE="$CACHE_DIR/cache-${SUITE}-${DPKG_ARCH}.tar"

TEMP=`getopt -o i:b:s: -n '$0' -- "$@"`

if [ $? != 0 ] ; then echo "Terminating..." >&2 ; exit 1 ; fi

# Note the quotes around `$TEMP': they are essential!
eval set -- "$TEMP"

while true; do
  case "$1" in
    -i) instance=$2; shift 2;;

    -b) blockdev=$2; shift 2;;

    -s) swapdev=$2; shift 2;;

    --) shift; break;;

    *)  echo "Internal error!"; exit 1;;
  esac
done
if [ -z "$instance" -o -z "$blockdev" -o -z "$swapdev" ]; then
  echo "Missing -i or -b or -s argument!"
  exit 1
fi

mkswap $swapdev
mke2fs -Fjq $blockdev
TMPDIR=`mktemp -d` || exit 1
trap "umount $TMPDIR; rmdir $TMPDIR" EXIT

# If it's not a block device try to mount it via loopback device.
# This is needed for file disks.
MOUNT_OPTIONS=""
if [ ! -b $blockdev ]; then
  MOUNT_OPTIONS="$MOUNT_OPTIONS -o loop"
fi
mount $MOUNT_OPTIONS $blockdev $TMPDIR

# remove the cache file if it's old (> 2 weeks) and writable by the owner (the
# default due to the standard umask)
if [ "$CLEAN_CACHE" -a -d "$CACHE_DIR" ]; then
  find "$CACHE_DIR" -name 'cache-*.tar' -type f \
    -daystart -mtime "+${CLEAN_CACHE}" -print0 | \
    xargs -r0 rm -f
fi

if [ -f "$CACHE_FILE" ]; then
  tar xf "$CACHE_FILE" -C $TMPDIR
else
  if [ "$PROXY" ]; then
    export http_proxy="$PROXY"
  fi
  # INCLUDE will be empty if EXTRA_PKGS is null/empty, otherwise we
  # build the full parameter format from it
  INCLUDE=${EXTRA_PKGS:+"--include=$EXTRA_PKGS"}
  debootstrap \
    --arch "$DPKG_ARCH" \
    $INCLUDE \
    "$SUITE" $TMPDIR $MIRROR

  # remove the downloaded debs, as they are no longer needed
  find "$TMPDIR/var/cache/apt/archives" -type f -name '*.deb' -print0 | \
    xargs -r0 rm -f

  # remove the persistent-net rules, otherwise it will remember the node's
  # interfaces as eth0, eth1, ...
  rm -f "$TMPDIR/etc/udev/rules.d/z25_persistent-net.rules"

  if [ "$GENERATE_CACHE" = "yes" ]; then
    TMP_CACHE=`mktemp "${CACHE_FILE}.XXXXXX"`
    tar cf "$TMP_CACHE" -C $TMPDIR .
    mv -f "$TMP_CACHE" "$CACHE_FILE"
  fi
fi

cp -p /etc/hosts $TMPDIR/etc/hosts
cp -p /etc/resolv.conf $TMPDIR/etc/resolv.conf
echo $instance > $TMPDIR/etc/hostname
echo $instance > $TMPDIR/etc/mailname

cat > $TMPDIR/etc/fstab <<EOF
# /etc/fstab: static file system information.
#
# <file system> <mount point>   <type>  <options>       <dump>  <pass>
/dev/sda        /               ext3    defaults        0       1
/dev/sdb        swap            swap    defaults        0       0
proc            /proc           proc    defaults        0       0
EOF

cat > $TMPDIR/etc/network/interfaces <<EOF
auto lo
iface lo inet loopback
EOF

umount $TMPDIR
rmdir $TMPDIR
trap - EXIT

exit 0
